const St = imports.gi.St;
const Main = imports.ui.main;
const Tweener = imports.ui.tweener;
const Gio=imports.gi.Gio;
const Lang=imports.lang;
const Mainloop=imports.mainloop;

let fcitx_hud=null;

const KimpanelIface = <interface name="org.kde.kimpanel.inputmethod">
<signal name="Enable">
    <arg type="b" direction="out" name="toenable" />
</signal>
</interface>;
const KimpanelProxy = Gio.DBusProxy.makeProxyWrapper(KimpanelIface);

const InputMethodIface=<interface name="org.fcitx.Fcitx.InputMethod">
	<method name="Configure">
	</method>
	<method name="ConfigureAddon">
		<arg type="s" direction="in" />
	</method>
	<method name="CreateIC">
	</method>
	<method name="CreateICv2">
	</method>
	<method name="CreateICv3">
	</method>
	<method name="Exit">
	</method>
	<method name="GetCurrentIM">
		<arg type="s" direction="out" />
	</method>
	<method name="GetIMAddon">
		<arg type="s" direction="in" />
	</method>
	<method name="ReloadConfig">
	</method>
	<method name="Restart">
	</method>
	<method name="SetCurrentIM">
	</method>
</interface>
const InputMethodProxy = Gio.DBusProxy.makeProxyWrapper(InputMethodIface);

function InputMethodDBus(){	 
	return new InputMethodProxy(Gio.DBus.session, 'org.fcitx.Fcitx-0','/inputmethod');
}

function KimpanelDBus(){
	return new KimpanelProxy(Gio.DBus.session, 'org.fcitx.Fcitx-0',
                         '/kimpanel');
}

function FcitxHUD(){
	this.im=InputMethodDBus();
    this.kim=KimpanelDBus();
    this.hud_display=null;
};

function dir(obj){
	for(var i in obj){
		global.log(i);
	}
}

FcitxHUD.prototype.enable=function(){
	this.signal_enable=this.kim.connectSignal("Enable",Lang.bind(this,function(sender,ver,toenable)
    {
    	if(toenable.toString()=="true"){
    		this.showHUD();
    	}
    }));
};

FcitxHUD.prototype.disable=function(){
	this.kim.disconnectSignal(this.signal_enable);
};

FcitxHUD.prototype.showHUD=function()
{
	let im_name=this.im.GetCurrentIMSync();
	if(!this.hud_display){
		this.hud_display=new St.Label({ style_class: 'hud_display', text: im_name.toString() });
       Main.uiGroup.add_actor(this.hud_display);
       this.hud_display.opacity = 200;
		let monitor = Main.layoutManager.primaryMonitor;
		this.hud_display.set_position(Math.floor(monitor.width / 2 - this.hud_display.width / 2),
                      Math.floor(monitor.height / 2 - this.hud_display.height / 2));
		Tweener.addTween(this.hud_display,
                     { opacity: 0,
                       time: 2,
                       transition: 'easeOutQuad',
                       onComplete:Lang.bind(this,this.hideHUD) });
	}
};

FcitxHUD.prototype.hideHUD=function(){
	if(this.hud_display){
		Main.uiGroup.remove_actor(this.hud_display);
    	this.hud_display = null;
	}
};

function init() {
    if(fcitx_hud==null){
    	fcitx_hud=new FcitxHUD();
    }
}

function enable() {
    fcitx_hud.enable();
}

function disable() {
    fcitx_hud.disable();
}
